Matt's executability test with a few tweaks (e.g. to avoid using
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
2094283b 26# Berkley's nice.
96553aa7 27PATH="$PATH:/usr/ucb"
2094283b 28
e3442095 29if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
30 diffopt="-u"
31else
32 diffopt="-c"
33fi
34
a98cad00
WD
35HOME="$scratchdir"
36export HOME
37
3a4c683f
MP
38runtest() {
39 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
40 if eval "$2"
41 then
6f481bb0 42 echo "$ECHO_T done."
501972bf
MP
43 return 0
44 else
6f481bb0 45 echo "$ECHO_T failed!"
501972bf
MP
46 return 1
47 fi
3a4c683f
MP
48}
49
757287d8
WD
50# Call this if you want to filter out verbose messages (-v or -vv) from
51# the output of an rsync run (whittling the output down to just the file
52# messages). This isn't needed if you use -i without -v.
53filter_outfile() {
54 sed -e '/^building file list /d' \
55 -e '/^created directory /d' \
56 -e '/^done$/d' \
57 -e '/ --whole-file$/d' \
58 -e '/^total: /d' \
59 -e '/^$/,$d' \
60 <"$outfile" >"$outfile.new"
61 mv "$outfile.new" "$outfile"
62}
63
3a4c683f
MP
64printmsg() {
65 echo "$1"
66}
67
e052b21f 68
6773a779 69rsync_ls_lR() {
22558cdd 70 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls"
dfef3f10
MP
71}
72
73rsync_getgroups() {
74 "$TOOLDIR/getgroups"
57835c00
MP
75}
76
77
e052b21f 78####################
6f481bb0 79# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 80
3a4c683f 81hands_setup() {
501972bf 82 # Clean before creation
6f481bb0
WD
83 rm -rf "$fromdir"
84 rm -rf "$todir"
3d807132 85
e3442095
WD
86 [ -d "$tmpdir" ] || mkdir "$tmpdir"
87 [ -d "$fromdir" ] || mkdir "$fromdir"
88 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 89
e052b21f
MP
90 # On some BSD systems, the umask affects the mode of created
91 # symlinks, even though the mode apparently has no effect on how
92 # the links behave in the future, and it cannot be changed using
93 # chmod! rsync always sets its umask to 000 so that it can
94 # accurately recreate permissions, but this script is probably run
95 # with a different umask.
96
97 # This causes a little problem that "ls -l" of the two will not be
98 # the same. So, we need to set our umask before doing any creations.
99
3a4c683f 100 # set up test data
6f481bb0
WD
101 touch "$fromdir/empty"
102 mkdir "$fromdir/emptydir"
e8ca5901 103
571a4b26 104 # a hundred lines of text or so
6f481bb0 105 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 106
6f481bb0 107 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 108 umask 0
6f481bb0 109 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 110 umask 022
0154b302 111
db10766a 112 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
113 mkdir "$fromdir/dir"
114 cp "$fromdir/text" "$fromdir/dir"
115 mkdir "$fromdir/dir/subdir"
116 echo some data > "$fromdir/dir/subdir/foobar.baz"
117 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
118 if [ -r /etc ]; then
119 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
120 else
121 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
122 fi
6f481bb0 123 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
124 if [ -r /bin ]; then
125 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
126 else
127 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
128 fi
7d691654 129
8f98c608 130# echo testing head:
6f481bb0 131# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 132}
3fedd74b
MP
133
134
99cdaff7
MP
135####################
136# Many machines do not have "mkdir -p", so we have to build up long paths.
137# How boring.
138makepath () {
7c1b7890 139 echo " makepath $1"
99cdaff7
MP
140 p="$1"
141 (
142 # Absolut Unix.
143 if echo $p | grep '^/' >/dev/null
144 then
145 cd /
146 fi
147
148 # This will break if $1 contains a space.
149 for c in `echo $p | tr '/' ' '`
150 do
112e7311
MP
151 if [ -d "$c" ] || mkdir "$c"
152 then
153 cd "$c" || return $?
154 else
155 echo "failed to create $c" >&2; return $?
156 fi
99cdaff7
MP
157 done
158 )
159}
160
161
162
3fedd74b
MP
163###########################
164# Run a test (in '$1') then compare directories $2 and $3 to see if
165# there are any difference. If there are, explain them.
166
f494f286
MP
167# So normally basically $1 should be an rsync command, and $2 and $3
168# the source and destination directories. This is only good when you
169# expect to transfer the whole directory exactly as is. If some files
170# should be excluded, you might need to use something else.
171
3fedd74b 172checkit() {
3fedd74b 173 failed=
3fedd74b 174
cf72f204
MP
175 # We can just write everything to stdout/stderr, because the
176 # wrapper hides it unless there is a problem.
177
178 echo "Running: \"$1\""
179 eval "$1"
3fedd74b
MP
180 status=$?
181 if [ $status != 0 ]; then
182 failed="YES";
183 fi
184
cf72f204
MP
185 echo "-------------"
186 echo "check how the directory listings compare with diff:"
187 echo ""
6f481bb0
WD
188 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
189 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
190 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
191
192 echo "-------------"
193 echo "check how the files compare with diff:"
194 echo ""
195 if [ "x$4" != x ]; then
196 echo " === Skipping (as directed) ==="
197 else
198 diff -r $diffopt "$2" "$3" || failed=YES
199 fi
200
201 echo "-------------"
6f481bb0 202 if [ -z "$failed" ] ; then
3fedd74b
MP
203 return 0
204 else
3fedd74b
MP
205 return 1
206 fi
207}
208
863dff51 209
4a7cb3e8 210build_rsyncd_conf() {
d2094cc3
MP
211 # Build an appropriate configuration file
212 conf="$scratchdir/test-rsyncd.conf"
213 echo "building configuration $conf"
214
215 port=2612
216 pidfile="$scratchdir/rsyncd.pid"
217 logfile="$scratchdir/rsyncd.log"
218
6f481bb0 219 cat >"$conf" <<EOF
3aae15ec 220# rsyncd configuration file autogenerated by $0
d2094cc3 221
3aae15ec
MP
222pid file = $pidfile
223use chroot = no
224hosts allow = localhost, 127.0.0.1
225log file = $logfile
6f481bb0 226exclude = foobar.baz
eddeaf76 227max verbosity = 9
d2094cc3 228
76ee1d18
WD
229uid = 0
230gid = 0
98c1b325 231
2e6c7f45 232[test-from]
6f481bb0 233 path = $fromdir
3aae15ec 234 read only = yes
d2094cc3 235
2e6c7f45 236[test-to]
6f481bb0 237 path = $todir
3aae15ec 238 read only = no
d2094cc3
MP
239EOF
240}
241
242
3cd2af41 243build_symlinks() {
3cd2af41
MP
244 mkdir "$fromdir"
245 date >"$fromdir/referent"
246 ln -s referent "$fromdir/relative"
247 ln -s "$fromdir/referent" "$fromdir/absolute"
248 ln -s nonexistent "$fromdir/dangling"
1db8b61d 249 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
250}
251
252test_fail() {
253 echo "$@" >&2
254 exit 1
255}
256
a217ad30
MP
257test_skipped() {
258 echo "$@" >&2
6f481bb0 259 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
260 exit 77
261}
262
be2f866b
MP
263# It failed, but we expected that. don't dump out error logs,
264# because most users won't want to see them. But do leave
265# the working directory around.
266test_xfail() {
267 echo "$@" >&2
268 exit 78
269}
270
d1239eae
MP
271# Determine what shell command will appropriately test for links.
272ln -s foo "$scratchdir/testlink"
273for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
274do
275 for switch in -h -L
276 do
277 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
278 then
279 # how nice
280 TEST_SYMLINK_CMD="$cmd $switch"
281 # i wonder if break 2 is portable?
282 break 2
283 fi
284 done
285done
cca4e067
MP
286# ok, now get rid of it
287rm "$scratchdir/testlink"
d1239eae
MP
288
289
290if [ "x$TEST_SYMLINK_CMD" = 'x' ]
291then
292 test_fail "Couldn't determine how to test for symlinks"
293else
294 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
295fi
296
297
d96d3893
MP
298# Test whether something is a link, allowing for shell peculiarities
299is_a_link() {
d1239eae
MP
300 # note the variable contains the first option and therefore is not quoted
301 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
302}
303
77867907
MP
304
305# We need to set the umask to be reproducible. Note also that when we
306# do some daemon tests as root, we will setuid() and therefore the
307# directory has to be writable by the nobody user in some cases. The
308# best thing is probably to explicitly chmod those directories after
309# creation.
310
ad301e48 311umask 022